/**
 * 0xGG Team
 * Distributed under AGPL3
 *
 * DESCRIPTION: Inline code fold that aims to get VickyWidgets work `@appname arg1=val1 arg2=val2`
 */

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("./fold"), require("../widget/index"), require("../widget/hello/hello"), require("../widget/error/error"), require("../widget/timer/timer")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","./fold","../widget/index","../widget/hello/hello","../widget/error/error","../widget/timer/timer"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.FoldWidget = this.HyperMD.FoldWidget || {}), HyperMD.Fold, HyperMD.Widget, HyperMD.WidgetHello, HyperMD.WidgetError, HyperMD.WidgetTimer);
})(function (require, exports, fold_1, index_1, hello_1, error_1, timer_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    index_1.registerWidgetCreator("hello", hello_1.HelloWidget);
    index_1.registerWidgetCreator("error", error_1.ErrorWidget);
    index_1.registerWidgetCreator("timer", timer_1.TimerWidget);
    exports.WidgetFolder = function (stream, token) {
        if (token.type !== "inline-code" || !token.string.trim().startsWith("@")) {
            return null;
        }
        var start = token.start;
        var cm = stream.cm;
        var line = cm.getLine(stream.lineNo);
        var end = token.end;
        // TODO: variable `end` here might be wrong
        // TODO: Support multiple line inline_code
        for (; end < line.length; end++) {
            if (line[end] === "`" && line[end - 1] !== "\\") {
                break;
            }
        }
        var str = line.slice(start, end).trim();
        // Include "`"
        start = start - 1;
        end = end + 1;
        var widgetName;
        var widgetAttributes = {};
        var firstSpaceMatch = str.match(/\s/);
        var firstSpace = firstSpaceMatch ? firstSpaceMatch.index : -1;
        if (firstSpace > 0) {
            widgetName = str
                .slice(0, firstSpace)
                .trim()
                .replace(/^@/, "");
            try {
                var j = str.slice(firstSpace + 1).trim();
                if (j[0] === "{") {
                    widgetAttributes = JSON.parse(j);
                }
                else {
                    widgetAttributes = JSON.parse("{" + j + "}");
                }
            }
            catch (error) {
                widgetName = "error";
                widgetAttributes = { message: error.toString() };
            }
        }
        else {
            widgetName = str.trim().replace(/^@/, "");
        }
        if (!widgetName) {
            return null;
        }
        /*
        console.log("stream: ", stream);
        console.log("token: ", token);
        console.log("str: ", str);
        console.log("widgetName: ", widgetName);
        console.log("widgetAttributes: ", widgetAttributes);
        */
        var from = { line: stream.lineNo, ch: start };
        var to = { line: stream.lineNo, ch: end };
        var reqAns = stream.requestRange(from, to);
        if (reqAns !== fold_1.RequestRangeResult.OK)
            return null;
        var setAttributes = function (attributes) {
            var editor = cm;
            if (!editor) {
                return;
            }
            var widgetFrom = { line: from.line, ch: from.ch };
            var widgetTo = { line: to.line, ch: to.ch };
            var line = editor.getLine(from.line);
            if (!line) {
                throw new Error("Failed to update widget attributes");
            }
            var end = widgetFrom.ch + 1;
            for (; end < line.length; end++) {
                if (line[end - 1] !== "\\" && line[end] === "`") {
                    end++;
                    break;
                }
            }
            widgetTo.ch = end;
            var widgetName = line
                .slice(widgetFrom.ch + 1, widgetTo.ch)
                .match(/^\@[^\s$`]+/)[0];
            editor.replaceRange("`" + widgetName + " " + JSON.stringify(attributes)
                .replace(/^{/, "")
                .replace(/}$/, "") + "`", widgetFrom, widgetTo);
        };
        var replaceSelf = function (inputString) {
            var editor = cm;
            if (!editor) {
                return;
            }
            var widgetFrom = { line: from.line, ch: from.ch };
            var widgetTo = { line: to.line, ch: to.ch };
            var line = editor.getLine(from.line);
            if (!line) {
                throw new Error("Failed to update widget attributes");
            }
            var end = widgetFrom.ch + 1;
            for (; end < line.length; end++) {
                if (line[end - 1] !== "\\" && line[end] === "`") {
                    end++;
                    break;
                }
            }
            widgetTo.ch = end;
            editor.replaceRange(inputString, widgetFrom, widgetTo);
            editor.focus();
        };
        var removeSelf = function () {
            return replaceSelf("");
        };
        // Create the widget
        var widget;
        var widgetCreator = index_1.getWidgetCreator(widgetName);
        if (!widgetCreator) {
            return false;
        }
        else {
            widget = widgetCreator({
                attributes: widgetAttributes,
                setAttributes: setAttributes,
                removeSelf: removeSelf,
                replaceSelf: replaceSelf,
                isPreview: false
            });
        }
        // Create widget here
        var marker = cm.markText(from, to, {
            replacedWith: widget,
            collapsed: true,
            inclusiveLeft: true,
            inclusiveRight: true
        });
        /*
        // 1 here means `
        widget.addEventListener("click", () => {
          breakMark(cm, marker, 1), false;
        });
        */
        return marker;
    };
    fold_1.registerFolder("widget", exports.WidgetFolder, true);
});
/*
example widget:

    `@timer "date":"Tue Dec 10 2019 10:54:07 GMT+0800 (China Standard Time)"`
*/
